"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Base64 = __importStar(require("base64-js"));
const fs = __importStar(require("fs"));
const mime_types_1 = __importDefault(require("mime-types"));
const Eos = require('eosjs');
const utils_1 = require("./utils");
const costants_1 = require("./costants");
const config = {
    chainId: costants_1.chainId,
    keyProvider: [costants_1.wif],
    httpEndpoint: 'https://api.eosnewyork.io',
    // TODO: changeable https://api.eosnewyork.io https://nodes.get-scatter.com
    expireInSeconds: 60,
    broadcast: true,
    verbose: false,
    sign: true
};
const eos = Eos(config);
function doTx(memo) {
    return new Promise((resolve) => {
        setTimeout(() => {
            // eos.transfer(from, 'eosfilestore', '0.0001 EOS', memo, (error: any, result: any) => {
            //   if (error) {
            //     console.error(error)
            //   }
            //   // console.log('..',JSON.stringify(result))
            //   resolve(result)
            // })
            const options = {
                authorization: [`${costants_1.from}@${costants_1.permission}`]
            };
            eos.contract('eosfilestore').then((contract) => {
                contract.upload(memo, options).then((res) => {
                    resolve(res);
                });
            });
        }, 100); // NOTE: rate limit?
    });
}
exports.doTx = doTx;
// just to test promises
// async function fakeTransferPromise(memo: string): Promise<any> {
//   return new Promise((resolve: any) => {
//     setTimeout(async () => {
//       await resolve({ transaction_id: Math.random().toString() })
//     }, 2000);
//   })
// }
function fetchTx(txid, buffer) {
    return new Promise((resolve) => {
        eos.getTransaction(txid).then((data) => {
            // console.log(JSON.stringify(data.trx.trx.actions[0].data.msg))
            // console.log(data.trx.trx.actions[0].data.memo) // data.trx.trx.actions[0].data.memo
            // const memo = JSON.parse(data.trx.trx.actions[0].data.memo)
            const memo = JSON.parse(data.trx.trx.actions[0].data.msg);
            console.log(`${memo.n}`); // verbose
            if (memo.n) {
                resolve(fetchTx(memo.n, `${buffer}${memo.c}`));
            }
            else {
                resolve(`${buffer}${memo.c}`);
            }
        });
    });
}
exports.fetchTx = fetchTx;
function prepareChunks(filepath) {
    return new Promise((resolve, reject) => {
        fs.readFile(filepath, (err, data) => {
            if (err) {
                console.error(err);
                reject([]);
            }
            const blob = Base64.fromByteArray(data);
            const mimetype = mime_types_1.default.lookup(filepath);
            const dataString = `data:${mimetype};base64,${blob}`;
            // console.log(dataString)
            const chunks = utils_1.splitString(dataString, costants_1.maxPayloadSize);
            resolve(chunks);
        });
    });
}
exports.prepareChunks = prepareChunks;
