"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const fs_1 = __importDefault(require("fs"));
function loadConfig() {
    const confDir = `${process.env.HOME}/.eosfilestore`;
    // write default config.js in the first run
    if (!fs_1.default.existsSync(confDir)) {
        fs_1.default.mkdirSync(confDir);
        fs_1.default.writeFileSync(`${confDir}/config.json`, `
{
  "from":"",
  "privateKey":"",
  "permission":"active"
}
    `);
        console.log(`eosfilestore: Generated '${confDir}/config.json', please edit with your EOS keys`);
    }
    // read config
    const configFile = fs_1.default.readFileSync(`${confDir}/config.json`).toLocaleString();
    return JSON.parse(configFile);
}
const confObj = loadConfig();
// console.log('cc', confObj)
exports.maxPayloadSize = 10000; // 429496 // 176 // 4294967294
exports.costPerTx = 0.0001;
exports.chainId = confObj.chainId || 'aca376f206b8fc25a6ed44dbdc66547c36c6c33e3a119ffbeaef943642f0e906'; // mainnet
exports.wif = confObj.privateKey;
exports.from = confObj.from;
exports.permission = confObj.permission || 'active';
